package at.jku.fim.datalinksimulation.layer1.devices;


import at.jku.fim.datalinksimulation.genericdevices.InterlinkingDevice;
import at.jku.fim.datalinksimulation.networkstack.incoming.DecodingNetworkFilter;
import at.jku.fim.datalinksimulation.networkstack.incoming.IncomingNetworkStackConfiguration;
import at.jku.fim.datalinksimulation.networkstack.outgoing.EncodingNetworkFilter;
import at.jku.fim.datalinksimulation.networkstack.outgoing.OutgoingNetworkStackConfiguration;

/**
 * <p>Title: OSI Simulation Framework</p>
 * This class represents an implementation of a typical network hub.<BR>
 * The data received on one port is forwarded to all the other ports. In this
 * implementation the number of ports can be specified at instantiation time.
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: Hub.java,v 1.1 2005/10/27 13:10:11 aputzinger Exp $
 */

public class Hub extends InterlinkingDevice {

	/**
	 * Constructor
	 * @param identifier Identifiert for log
	 * @param numberOfPorts The number of available physical ports
	 */
	public Hub(String identifier, int numberOfPorts) {
		super(identifier, numberOfPorts);
	}

    /*
	 * (non-Javadoc) - no filters are installed
	 * 
	 * @see at.jku.fim.datalinksimulation.InterlinkingDevice#getIncomingNetworkStackConfiguration()
	 */
	protected IncomingNetworkStackConfiguration getIncomingNetworkStackConfiguration() {
		return new IncomingNetworkStackConfiguration() {
			public DecodingNetworkFilter[] getDecodingFilters(int osiLevel) {
				return null;
			}
		};
	}

	/*
	 * (non-Javadoc) - no filters are installed
	 * 
	 * @see at.jku.fim.datalinksimulation.InterlinkingDevice#getOutgoingNetworkStackConfiguration()
	 */
	protected OutgoingNetworkStackConfiguration getOutgoingNetworkStackConfiguration() {
		return new OutgoingNetworkStackConfiguration() {
			public EncodingNetworkFilter[] getEncodingFilters(int osiLevel) {
				return null;
			}
		};
	}

}