package at.jku.fim.datalinksimulation.layer7;

import at.jku.fim.datalinksimulation.networkstack.NetworkStack;
import at.jku.fim.datalinksimulation.networkstack.incoming.IncomingNetworkStackObserver;
import at.jku.fim.datalinksimulation.utils.Logger;

/**
 * <p>Title: OSI Simulation Framework</p>
 * Base class for simulated applications
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: Application.java,v 1.1 2005/10/27 13:10:11 aputzinger Exp $
 */

public abstract class Application implements IncomingNetworkStackObserver {

    protected NetworkStack networkStackReference = null;

    public Application(NetworkStack networkStackReference) {
    	this.networkStackReference = networkStackReference;
    }
    
    /**
     * @return Returns associated network stack
     */
    public NetworkStack getNetworkStack() {
        return networkStackReference;
    }

    /**
     * Set network stack reference
     * @param networkStack
     */
	public void setNetworkStack(NetworkStack networkStack) {
		this.networkStackReference = networkStack;
	}

	/**
	 * @return Returns logger instance or null, if not available
	 */
	public abstract Logger getLogger(); 
}