package at.jku.fim.datalinksimulation.layer7.networkdevice;

import at.jku.fim.datalinksimulation.layer1.data.RawData;
import at.jku.fim.datalinksimulation.layer7.Application;
import at.jku.fim.datalinksimulation.networkstack.NetworkStack;
import at.jku.fim.datalinksimulation.networkstack.NetworkStackParameters;
import at.jku.fim.datalinksimulation.utils.Logger;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: DataReflectApplication.java,v 1.1 2005/10/27 13:10:11 aputzinger Exp $
 */

public class DataReflectApplication extends Application {

    /**
     * Constructor
     */
    public DataReflectApplication(NetworkStack networkStack) {
    	super(networkStack);
    }

	/*
	 * # (non-Javadoc)
	 * 
	 * @see at.jku.fim.datalinksimulation.networkstack.IncomingNetworkStackObserver#informAboutNewData(at.jku.fim.datalinksimulation.networkstack.NetworkStackParameters,
	 *      at.jku.fim.datalinksimulation.data.RawData)
	 */
	public void informAboutNewData(NetworkStackParameters params, RawData data) {
		getNetworkStack().sendToWorld(null, data, params);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see at.jku.fim.datalinksimulation.layer7.Application#getLogger()
	 */
	public Logger getLogger() {
		return null;
	}

}