package at.jku.fim.datalinksimulation.scenario.gui;

import java.awt.*;
import javax.swing.*;

import at.jku.fim.datalinksimulation.utils.ConversionUtils;

import java.awt.event.*;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: ReceiverPanel.java,v 1.1 2005/10/27 13:10:08 aputzinger Exp $
 */

public class ReceiverPanel extends JPanel {

	private static final long serialVersionUID = -1542558857579484175L;

	String stationID = "N/A";

    String senderID = "N/A";

    JScrollPane jScrollPane1 = new JScrollPane();

    JTextArea plainText = new JTextArea();

    JLabel stationIDLabel = new JLabel();

    JTabbedPane textPanel = new JTabbedPane();

    JPanel plainTextTab = new JPanel();

    JPanel hexTab = new JPanel();

    BorderLayout borderLayout1 = new BorderLayout();

    BorderLayout borderLayout2 = new BorderLayout();

    JScrollPane jScrollPane2 = new JScrollPane();

    JTextArea hexText = new JTextArea();

    JPanel jPanel2 = new JPanel();

    BorderLayout borderLayout4 = new BorderLayout();

    JPanel jPanel3 = new JPanel();

    BorderLayout borderLayout5 = new BorderLayout();

    BorderLayout borderLayout6 = new BorderLayout();

    JPanel jPanel1 = new JPanel();

    JLabel senderIdLabel = new JLabel();

    BorderLayout borderLayout3 = new BorderLayout();

    public ReceiverPanel() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        this.setLayout(borderLayout5);
        plainText.setBackground(UIManager.getColor("ToolBar.background"));
        plainText.setForeground(Color.blue);
        plainText.setEditable(false);
        plainText.setText("");
        this.setBackground(UIManager.getColor("ToolBar.background"));
        this.setBorder(BorderFactory.createRaisedBevelBorder());
        this.setMaximumSize(new Dimension(32767, 32767));
        stationIDLabel.setFont(new java.awt.Font("Dialog", 1, 12));
        stationIDLabel.setToolTipText("");
        stationIDLabel.setText("N/A");
        setStationID("1");
        textPanel.setTabPlacement(SwingConstants.BOTTOM);
        textPanel.addMouseListener(new ReceiverPanel_textPanel_mouseAdapter(
                this));
        plainTextTab.setLayout(borderLayout1);
        hexTab.setDebugGraphicsOptions(0);
        hexTab.setLayout(borderLayout2);
        hexText.setBackground(UIManager.getColor("ToolBar.background"));
        hexText.setForeground(Color.blue);
        hexText.setToolTipText("");
        hexText.setCaretColor(Color.black);
        hexText.setEditable(false);
        hexText.setText("");
        jPanel2.setLayout(borderLayout4);
        jPanel3.setBackground(Color.green);
        jPanel3.setLayout(borderLayout6);
        jPanel1.setLayout(borderLayout3);
        senderIdLabel.setText("N/A");
        textPanel.add(plainTextTab, "Plain Text");
        plainTextTab.add(jScrollPane1, BorderLayout.CENTER);
        textPanel.add(hexTab, "Hex Text");
        hexTab.add(jScrollPane2, BorderLayout.CENTER);
        this.add(jPanel3, BorderLayout.NORTH);
        jPanel3.add(stationIDLabel, BorderLayout.CENTER);
        jPanel3.add(jPanel1, BorderLayout.SOUTH);
        jPanel1.add(senderIdLabel, BorderLayout.CENTER);
        jScrollPane2.getViewport().add(hexText, null);
        jScrollPane1.getViewport().add(plainText, null);
        textPanel.setSelectedIndex(0);
        this.add(jPanel2, BorderLayout.CENTER);
        jPanel2.add(textPanel, BorderLayout.CENTER);
    }

    public String getStationID() {
        return stationID;
    }

    public void setStationID(String stationID) {
        this.stationID = stationID;
        stationIDLabel.setText("Station ID: <" + stationID + "> (Receiver)");
    }

    public String getSenderID() {
        return senderID;
    }

    public void setSenderID(String senderID) {
        if (senderID == null)
            senderID = "N/A";
        this.senderID = senderID;
        senderIdLabel.setText("Text received from station <" + senderID + ">");
    }

    public JTextArea getHexText() {
        return hexText;
    }

    public JTextArea getPlainText() {
        return plainText;
    }

    void textPanel_mouseClicked(MouseEvent e) {
        hexText.setText(ConversionUtils.stringToHex(plainText.getText()));
    }

}

class ReceiverPanel_textPanel_mouseAdapter extends java.awt.event.MouseAdapter {
    ReceiverPanel adaptee;

    ReceiverPanel_textPanel_mouseAdapter(ReceiverPanel adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.textPanel_mouseClicked(e);
    }
}