package at.jku.fim.datalinksimulation.scenario.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import at.jku.fim.datalinksimulation.layer7.enduser.TextSendingApplication;
import at.jku.fim.datalinksimulation.utils.ConversionUtils;
import at.jku.fim.datalinksimulation.utils.Logger;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: SenderPanel.java,v 1.1 2005/10/27 13:10:08 aputzinger Exp $
 */

public class SenderPanel extends JPanel {

	private static final long serialVersionUID = 905977109785628885L;

	String stationID = "N/A";

    TextSendingApplication controller = null;

    JScrollPane jScrollPane1 = new JScrollPane();

    JTextArea plainText = new JTextArea();

    JLabel stationIDLabel = new JLabel();

    JLabel senderLabel = new JLabel();

    JTextField receiverId = new JTextField();

    JTabbedPane textPanel = new JTabbedPane();

    JPanel plainTextTab = new JPanel();

    JPanel hexTab = new JPanel();

    BorderLayout borderLayout1 = new BorderLayout();

    BorderLayout borderLayout2 = new BorderLayout();

    JScrollPane jScrollPane2 = new JScrollPane();

    JTextArea hexText = new JTextArea();

    JButton sendButton = new JButton();

    JPanel jPanel1 = new JPanel();

    BorderLayout borderLayout3 = new BorderLayout();

    JPanel jPanel2 = new JPanel();

    BorderLayout borderLayout4 = new BorderLayout();

    Component component1;

    JPanel jPanel3 = new JPanel();

    BorderLayout borderLayout5 = new BorderLayout();

    BorderLayout borderLayout6 = new BorderLayout();

    JLabel messageLabel = new JLabel();

    public SenderPanel(TextSendingApplication controller) {
        this.controller = controller;
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        component1 = Box.createVerticalStrut(8);
        this.setLayout(borderLayout5);
        plainText.setForeground(Color.black);
        plainText.setText("");
        this.setBackground(UIManager.getColor("ToolBar.background"));
        this.setBorder(BorderFactory.createRaisedBevelBorder());
        this.setMaximumSize(new Dimension(32767, 32767));
        stationIDLabel.setFont(new java.awt.Font("Dialog", 1, 12));
        stationIDLabel.setToolTipText("");
        stationIDLabel.setText("N/A");
        setStationID("1");
        senderLabel.setText("Receiver ID:");
        receiverId.setText("");
        textPanel.setTabPlacement(SwingConstants.BOTTOM);
        plainTextTab.setLayout(borderLayout1);
        hexTab.setDebugGraphicsOptions(0);
        hexTab.addFocusListener(new SenderPanel_hexTab_focusAdapter(this));
        hexTab.setLayout(borderLayout2);
        hexText.setBackground(UIManager.getColor("ToolBar.background"));
        hexText.setCaretColor(Color.black);
        hexText.setEditable(false);
        hexText.setText("");
        sendButton.setActionCommand("send");
        sendButton.setText("Send Text");
        sendButton.addActionListener(new SenderPanel_sendButton_actionAdapter(
                this));
        jPanel1.setDebugGraphicsOptions(0);
        jPanel1.setLayout(borderLayout3);
        jPanel2.setLayout(borderLayout4);
        jPanel3.setBackground(Color.orange);
        jPanel3.setLayout(borderLayout6);
        messageLabel.setText("Ready");
        textPanel.add(plainTextTab, "Plain Text");
        plainTextTab.add(jScrollPane1, BorderLayout.CENTER);
        textPanel.add(hexTab, "Hex Text");
        hexTab.add(jScrollPane2, BorderLayout.CENTER);
        jPanel2.add(messageLabel, BorderLayout.SOUTH);
        this.add(jPanel3, BorderLayout.NORTH);
        jPanel3.add(stationIDLabel, BorderLayout.CENTER);
        jPanel2.add(jPanel1, BorderLayout.NORTH);
        jScrollPane2.getViewport().add(hexText, null);
        jScrollPane1.getViewport().add(plainText, null);
        textPanel.setSelectedIndex(0);
        jPanel1.add(component1, BorderLayout.SOUTH);
        jPanel1.add(receiverId, BorderLayout.CENTER);
        jPanel1.add(senderLabel, BorderLayout.WEST);
        jPanel1.add(sendButton, BorderLayout.EAST);
        this.add(jPanel2, BorderLayout.CENTER);
        jPanel2.add(textPanel, BorderLayout.CENTER);
    }

    public String getStationID() {
        return stationID;
    }

    public void setStationID(String stationID) {
        this.stationID = stationID;
        stationIDLabel.setText("Station ID: <" + stationID + "> (Sender)");
    }

    void sendButton_actionPerformed(ActionEvent e) {
        Logger.globalTime++;
        SimulationApplication.frame.stationsReset();
        if (controller != null)
            controller.sendButtonPressed(e);
        SimulationApplication.frame.logUpdate();
    }

    public JTextArea getHexText() {
        return hexText;
    }

    public JTextArea getPlainText() {
        return plainText;
    }

    public JTextField getReceiverId() {
        return receiverId;
    }

    public JLabel getMessageLabel() {
        return messageLabel;
    }

    void hexTab_focusGained(FocusEvent e) {
        hexText.setText(ConversionUtils.stringToHex(plainText.getText()));
    }

}

class SenderPanel_sendButton_actionAdapter implements
        java.awt.event.ActionListener {
    SenderPanel adaptee;

    SenderPanel_sendButton_actionAdapter(SenderPanel adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.sendButton_actionPerformed(e);
    }
}

class SenderPanel_hexTab_focusAdapter extends java.awt.event.FocusAdapter {
    SenderPanel adaptee;

    SenderPanel_hexTab_focusAdapter(SenderPanel adaptee) {
        this.adaptee = adaptee;
    }

    public void focusGained(FocusEvent e) {
        adaptee.hexTab_focusGained(e);
    }
}